;T24_as_adc7_10bt.asm
;Zwischen alle 7 Pins PA0 bis PA6 sowie Pin PB2 und Masse sind
;Low Current Leuchtdioden ueber Widerstaende von jeweils 4,7kOhm
;angeschlossen, um die Mikrocontrollerausgaenge nur wenig
;zu belasten.
;Ausserdem ist je eine Leuchtdiode ueber einen Widerstand von 4,7k
;zwischen PB0,PB1 sowie PB2 und Masse angeschlossen.
;Zwischen dem Pin Vcc des ATtiny24 und Masse kann zur Erprobung des
;Mikrocontroller-Programms ein Trimmpotenziometer von 10 kOhm angeschlossen
;werden. Der Pin seines Schleifkontaktes wird mit PA7 des
;Mikrocontrollers verbunden.

.nolist
.include "tn24_26def.inc"
.list

	 rjmp anfang ; Reset Handler	
	 reti; rjmp INT0 ; IRQ0 Handler
 	 reti; rjmp PCINT0 ; PCINT0 Handler
	 reti; rjmp PCINT1 ; PCINT1 Handler
	 reti; rjmp WDT ; Watchdog Interrupt Handler
	 reti; rjmp TIM1_CAPT ; Timer1 Capture Handler
	 reti; rjmp TIM1_COMPA ; Timer1 Compare A Handler
	 reti; rjmp TIM1_COMPB ; Timer1 Compare B Handler
	 reti; rjmp TIM1_OVF ; Timer1 Overflow Handler
	 reti; rjmp TIM0_COMPA ; Timer0 Compare A Handler
	 reti; rjmp TIM0_COMPB ; Timer0 Compare B Handler
	 reti; rjmp TIM0_OVF ; Timer0 Overflow Handler
	 reti; rjmp ANA_COMP ; Analog Comparator Handler
	 reti; rjmp ADC ; ADC Conversion Handler
	 reti; rjmp EE_RDY ; EEPROM Ready Handler
	 reti; rjmp USI_STR ; USI STart Handler
	 reti; rjmp USI_OVF ; USI Overflow Handler
	

        
anfang:
        
        ldi r16,low(RAMEND)
        out spl,r16

	ldi r16,0b01111111
	out ddra,r16
	ldi r16,0b00000111
	out ddrb,r16
	;sbi DIDR0,ADC7D   ;Digital Input 7 disable
	ldi r16,3	   ;Divisionsfaktor 8
	out ADCSRA,r16
	sbi ADCSRA,ADEN    ;ADC Enable

loop:
	rcall RdADC
	mov r18,r16	   ;Inhalt von r16 nach r18
	andi r16,0x7F      ;da nur die Bits 0..6 von PortA Ausgaenge sind                      sind   
	andi r18,0x80      ;Zustand von Bit7 in r18 wird hier benoetigt
	out porta,r16	   ;Ausgabe des Inhalts von r16 an PortA
	tst r18            ;Teste r18 auf Null 
	breq bit7_n	   ;wenn ja, nach bit7_n 
	sbi portb,2        ;wenn nein, portb.2 setzen
	rjmp bit8_tst 
bit7_n:
	cbi portb,2        ;portb.2 --> Bit7
bit8_tst:
	mov r18,r17
	andi r17,0x01
	tst r17            ;Bit 8 uebernimmt PortB.0
	breq bit8_n
	sbi portb,0        ;portb.0 --> Bit8
	rjmp bit9_tst
		         
bit8_n:
	cbi portb,0	   ;portb.0 --> Bit8

bit9_tst:
	andi r18,0x02
	tst r18            ;Bit 9 uebernimmt PortB.1
	breq bit9_n
	sbi portb,1        ;portb.1 --> Bit9 
	rjmp P_aus_e
bit9_n:
	cbi portb,1	   ;portb.1 --> Bit9

P_aus_e:	
	rjmp loop	

RdADC:
	ldi r16,0b00000111 ;ADC7 auswaehlen
	out ADMUX,r16      ;Analogref.:Vcc
	cbi ADCSRB,ADLAR   ;10-Bit-Aufloesung 
	sbi ADCSRA,ADSC    ;ADC Start Conversion 
AD_rd1:
	sbic ADCSRA,ADSC
	rjmp AD_rd1
	sbi ADCSRA,ADSC
	
AD_rd2:
	sbic ADCSRA,ADSC
	rjmp AD_rd2
	in r16,ADCL
	in r17,ADCH   
	ret       
        