;T24_as_adc7_4bt.asm
;Zwischen alle 7 Pins PA0 bis PA6 sowie Pin PB2 und Masse sind
;Low Current Leuchtdioden ueber Vorwiderstaende von 4,7kOhm
;angeschlossen, um die Mikrocontrollerausgaenge nur wenig
;zu belasten.
;Zwischen dem Pin Vcc des ATtiny24 und Masse kann zur Erprobung des
;Mikrocontroller-Programms ein Trimmpotenziometer von 10 kOhm angeschlossen
;werden. Der Anschluss seines Schleifkontaktes wird mit PA7 des
;Mikrocontrollers verbunden.
 
.nolist
.include "tn24_26def.inc"
.list

	 rjmp anfang ; Reset Handler	
	 reti; rjmp INT0 ; IRQ0 Handler
 	 reti; rjmp PCINT0 ; PCINT0 Handler
	 reti; rjmp PCINT1 ; PCINT1 Handler
	 reti; rjmp WDT ; Watchdog Interrupt Handler
	 reti; rjmp TIM1_CAPT ; Timer1 Capture Handler
	 reti; rjmp TIM1_COMPA ; Timer1 Compare A Handler
	 reti; rjmp TIM1_COMPB ; Timer1 Compare B Handler
	 reti; rjmp TIM1_OVF ; Timer1 Overflow Handler
	 reti; rjmp TIM0_COMPA ; Timer0 Compare A Handler
	 reti; rjmp TIM0_COMPB ; Timer0 Compare B Handler
	 reti; rjmp TIM0_OVF ; Timer0 Overflow Handler
	 reti; rjmp ANA_COMP ; Analog Comparator Handler
	 reti; rjmp ADC ; ADC Conversion Handler
	 reti; rjmp EE_RDY ; EEPROM Ready Handler
	 reti; rjmp USI_STR ; USI STart Handler
	 reti; rjmp USI_OVF ; USI Overflow Handler
	

        
anfang:
        
        ldi r16,low(RAMEND)
        out spl,r16

	ldi r16,0b01111111 ;Pins 0..6 von PortA sind Ausgaenge 
	out ddra,r16
	ldi r16,0b00000111 ;Pins 0..2 von PortB sind Ausgaenge
	out ddrb,r16
	sbi DIDR0,ADC7D    ;Digital Input 7 disable
	ldi r16,3	   ;Divisionsfaktor 8
	out ADCSRA,r16
	sbi ADCSRA,ADEN    ;ADC Enable

loop:
	rcall RdADC        ;Analogeingang abfragen
	lsr r16
        lsr r16
	lsr r16
	lsr r16
        out porta,r16
	rjmp loop	

RdADC:
	ldi r16,0b00000111 ;ADC7 auswaehlen
	out ADMUX,r16      ;Analogref.:Vcc
	sbi ADCSRB,ADLAR   ;left adjust, 8-Bit-Aufloesung 
	sbi ADCSRA,ADSC    ;ADC Start Conversion 
AD_rd1:
	sbic ADCSRA,ADSC
	rjmp AD_rd1
	sbi ADCSRA,ADSC
	
AD_rd2:
	sbic ADCSRA,ADSC
	rjmp AD_rd2
	in r16,ADCH   
	ret       
        