#!/usr/bin/python2.7
#prog_EEPROM3.py

#Wesentliche Hinweise zur ISP-Programmierung
#von Atmel-Controllern finden sich neben 
#den Angaben in den Datenblaettern der betreffenden #Mikrocontroller u. a. in inzwischen vergriffenen #Fachbuechern von W.Trampert sowie B.Kainka (vgl #Literaturangaben zum Beitrag).

#H. Nieder, Fruehjahr 2015
#aktualisierte Version vom Januar 2016

import sys
import time
import RPi.GPIO as GPIO


#GPIO-Pins
MOSI=8
SCK =7
MISO=25
RES=23
#Test
STR=24


#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

GPIO.setup(MOSI,GPIO.OUT)
GPIO.setup(SCK,GPIO.OUT)
GPIO.setup(STR,GPIO.OUT)
GPIO.setup(RES,GPIO.OUT)
GPIO.setup(MISO,GPIO.IN)

out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#Anfangszustand
out(STR,hi)
out(RES,low)
Byte=0

z=0
k=0
wordzahl=0
zahl2er=0
page_r=0
page_eeprom=0


def pulse_STR():
    out(STR,low)
    time.sleep(0.005)
    out(STR,hi)

#Umwandlung Hex--> Dez, hier mit Dictionary
DEZ_dt={"0":0,"1":1,"2":2,"3":3,"4":4,"5":5,"6":6,"7":7,"8":8,"9":9,"A":10,"B":11,"C":12,"D":13,"E":14,"F":15}
def HexToInt(Hexzahl):
    H=0
    L=0
    Hnib=Hexzahl[0:1]  
    Lnib=Hexzahl[1:2]
    Ergebnis=16*DEZ_dt[Hnib]+DEZ_dt[Lnib]    
    Byte=Ergebnis
    return Byte

#Umwandlung Dez-->Hex
HEX_dt=("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F")
def ByteToHex(Byte):
    Lo_nib=0
    Hi_nib=0     
    Hi_nib=Byte/16
    Lo_nib=Byte%16      
    ByteHex=HEX_dt[Hi_nib]+HEX_dt[Lo_nib]      
    return ByteHex


def SPI_ein():
    out(SCK,hi)
    Byte_in=0
    Bit7=128
    n=0
    for n in range(0,8):             
        out(SCK,low)
        time.sleep(0.0001)
        if (GPIO.input(MISO)):
            Byte_in=Byte_in+Bit7               
        time.sleep(0.0001)
        out(SCK,hi)
        time.sleep(0.0001)                
        Bit7=Bit7>>1#1 Bit nach rechts schieben        
    time.sleep(0.0001)
    Ergebnis=Byte_in
    Zahl=ByteToHex(Byte_in)
    print Zahl, 


def SPI_aus(Byte):
    #Byte=255-Byte 
    Bit7_wt=128
    n=0
    for n in range(0,8):
        if (Byte & Bit7_wt) >0:
            out(MOSI,low)      
        else:
            out(MOSI,hi)
        time.sleep(0.0002)
        out(SCK,low)
        Bit7_wt=Bit7_wt>>1#1 Bit nach rechts schieben        
        time.sleep(0.0002)
        out(SCK,hi)
        time.sleep(0.0002)    
    out(MOSI,hi)




anzahl=0
anzahl1=0
anzahl_R=0

def prog_en():
    SPI_aus(0xAC)
    SPI_aus(0x53)
    SPI_aus(0)
    SPI_aus(0)    

def anzahl_lesen():
    global anzahl
    r=2048
    global page_z
    global page_r
    global page_r2
    global page_r1    
    global dat_str
    hexdatei=open(hex_datei)
    dat_str=""
    for k in range(0,r):
        dat_zeile=hexdatei.readline()        
        dat_ZL=dat_zeile[9:len(dat_zeile)-4]
        dat_str=dat_str+dat_ZL       
        Hexzahl=dat_zeile[1:3]
        if Hexzahl=="00":
            break
        anzahl=anzahl+ Byte
    dat_str_test=dat_str[0:4]     
    if dat_str_test=="0000":    
        dat_str=dat_str[4:len(dat_str)]    
    anzahl=len(dat_str)/2 
    print "Anzahl zu programmierender Bytes: ",anzahl    
    hexdatei.close() 


def eep_prog_dt():
    eep_ad=0
    eep_byte=0
    global z
    global anzahl
    
    dat_zeile=dat_str
    if anzahl<256:
        for p in range(0,anzahl):
            SPI_aus(0xC0)
            SPI_aus(0x00)
            SPI_aus(p) 
            Hexzahl=dat_zeile[z+0+p*2:z+2+p*2]            
            Byte=HexToInt(Hexzahl)            
            SPI_aus(Byte)

    if anzahl>255:
        anzahl_r=anzahl-256
        anzahl=256
        for p in range(0,anzahl):
            SPI_aus(0xC0)
            SPI_aus(0x00)
            SPI_aus(p) 
            Hexzahl=dat_zeile[z+0+p*2:z+2+p*2]            
            Byte=HexToInt(Hexzahl)            
            SPI_aus(Byte)

        anzahl=anzahl_r 
        for p in range(0,anzahl):
            SPI_aus(0xC0)
            SPI_aus(0x00)
            SPI_aus(p) 
            Hexzahl=dat_zeile[z+0+p*2:z+2+p*2]            
            Byte=HexToInt(Hexzahl)            
            SPI_aus(Byte)            

#Start
print
hex_datei=raw_input("EEPROM-HEX-Datei: ")
try:
    hexdatei=open(hex_datei)
except:
    print"Fehler im Dateinamen"
    sys.exit(0)
print
anzahl_lesen()
hexdatei.close()

out(RES,hi)
time.sleep(0.5)
prog_en()
time.sleep(0.5)
print 
print"EEPROM-Programmierung"
print
eep_prog_dt()
time.sleep(1)


print
print "Programmende"
print


out(MOSI,low)
out(SCK,low)
time.sleep(1)
out(RES,low)










